> ## Documentation Index
> Fetch the complete documentation index at: https://docs.tracecat.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Create Registry Repository

> Create a new registry repository.



## OpenAPI

````yaml https://platform.tracecat.com/api/openapi.json post /registry/repos
openapi: 3.1.0
info:
  title: Tracecat API
  summary: Tracecat API
  description: The open source AI automation platform for security teams and agents.
  termsOfService: >-
    https://docs.google.com/document/d/e/2PACX-1vQvDe3SoVAPoQc51MgfGCP71IqFYX_rMVEde8zC4qmBCec5f8PLKQRdxa6tsUABT8gWAR9J-EVs2CrQ/pub
  contact:
    name: Tracecat Founders
    email: founders@tracecat.com
  license:
    name: AGPL-3.0
    url: https://www.gnu.org/licenses/agpl-3.0.html
  version: '1'
servers:
  - url: /api
security: []
tags:
  - name: public
    description: Public facing endpoints
  - name: workflows
    description: Workflow management
  - name: actions
    description: Action management
  - name: triggers
    description: Workflow triggers
  - name: secrets
    description: Secret management
  - name: variables
    description: Workspace variable management
paths:
  /registry/repos:
    post:
      tags:
        - registry-repositories
      summary: Create Registry Repository
      description: Create a new registry repository.
      operationId: registry-repositories-create_registry_repository
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/RegistryRepositoryCreate'
        required: true
      responses:
        '201':
          description: Successful Response
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/RegistryRepositoryRead'
        '422':
          description: Validation Error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/HTTPValidationError'
      security:
        - APIKeyCookie: []
components:
  schemas:
    RegistryRepositoryCreate:
      properties:
        origin:
          type: string
          maxLength: 255
          minLength: 1
          title: Origin
          description: The origin of the repository
      type: object
      required:
        - origin
      title: RegistryRepositoryCreate
    RegistryRepositoryRead:
      properties:
        id:
          type: string
          format: uuid
          title: Id
        origin:
          type: string
          title: Origin
        last_synced_at:
          anyOf:
            - type: string
              format: date-time
            - type: 'null'
          title: Last Synced At
        commit_sha:
          anyOf:
            - type: string
            - type: 'null'
          title: Commit Sha
        current_version_id:
          anyOf:
            - type: string
              format: uuid
            - type: 'null'
          title: Current Version Id
        actions:
          items:
            $ref: '#/components/schemas/RegistryActionRead'
          type: array
          title: Actions
      type: object
      required:
        - id
        - origin
        - last_synced_at
        - commit_sha
        - actions
      title: RegistryRepositoryRead
    HTTPValidationError:
      properties:
        detail:
          items:
            $ref: '#/components/schemas/ValidationError'
          type: array
          title: Detail
      type: object
      title: HTTPValidationError
    RegistryActionRead:
      properties:
        name:
          type: string
          maxLength: 100
          minLength: 1
          title: Name
          description: The name of the action
        description:
          type: string
          maxLength: 1000
          title: Description
          description: The description of the action
        namespace:
          type: string
          title: Namespace
          description: The namespace of the action
        type:
          type: string
          enum:
            - udf
            - template
          title: Type
          description: The type of the action
        origin:
          type: string
          maxLength: 1000
          minLength: 1
          title: Origin
          description: The origin of the action as a url
        secrets:
          anyOf:
            - items:
                $ref: '#/components/schemas/RegistrySecretType'
              type: array
            - type: 'null'
          title: Secrets
          description: The secrets required by the action
        interface:
          $ref: '#/components/schemas/RegistryActionInterface'
        implementation:
          oneOf:
            - $ref: '#/components/schemas/RegistryActionTemplateImpl'
            - $ref: '#/components/schemas/RegistryActionUDFImpl'
          title: Implementation
          discriminator:
            propertyName: type
            mapping:
              template:
                $ref: '#/components/schemas/RegistryActionTemplateImpl'
              udf:
                $ref: '#/components/schemas/RegistryActionUDFImpl'
        default_title:
          anyOf:
            - type: string
              maxLength: 100
              minLength: 1
            - type: 'null'
          title: Default Title
          description: The default title of the action
        display_group:
          anyOf:
            - type: string
              maxLength: 100
              minLength: 1
            - type: 'null'
          title: Display Group
          description: The presentation group of the action
        doc_url:
          anyOf:
            - type: string
              maxLength: 1000
              minLength: 1
            - type: 'null'
          title: Doc Url
          description: Link to documentation
        author:
          anyOf:
            - type: string
              maxLength: 100
              minLength: 1
            - type: 'null'
          title: Author
          description: Author of the action
        deprecated:
          anyOf:
            - type: string
              maxLength: 1000
              minLength: 1
            - type: 'null'
          title: Deprecated
          description: Marks action as deprecated along with message
        options:
          $ref: '#/components/schemas/RegistryActionOptions'
          description: The options for the action
        repository_id:
          type: string
          format: uuid4
          title: Repository Id
          description: The repository id
        id:
          type: string
          format: uuid4
          title: Id
          description: The registry action id
        action:
          type: string
          title: Action
          description: The full action identifier.
          readOnly: true
        is_template:
          type: boolean
          title: Is Template
          description: Whether the action is a template.
          readOnly: true
      type: object
      required:
        - name
        - description
        - namespace
        - type
        - origin
        - interface
        - implementation
        - repository_id
        - id
        - action
        - is_template
      title: RegistryActionRead
      description: API read model for a registered action.
    ValidationError:
      properties:
        loc:
          items:
            anyOf:
              - type: string
              - type: integer
          type: array
          title: Location
        msg:
          type: string
          title: Message
        type:
          type: string
          title: Error Type
        input:
          title: Input
        ctx:
          type: object
          title: Context
      type: object
      required:
        - loc
        - msg
        - type
      title: ValidationError
    RegistrySecretType:
      oneOf:
        - $ref: '#/components/schemas/RegistrySecret'
        - $ref: '#/components/schemas/RegistryOAuthSecret'
      discriminator:
        propertyName: type
        mapping:
          custom:
            $ref: '#/components/schemas/RegistrySecret'
          oauth:
            $ref: '#/components/schemas/RegistryOAuthSecret'
    RegistryActionInterface:
      properties:
        expects:
          additionalProperties: true
          type: object
          title: Expects
        returns:
          title: Returns
      type: object
      required:
        - expects
        - returns
      title: RegistryActionInterface
    RegistryActionTemplateImpl:
      properties:
        type:
          type: string
          const: template
          title: Type
          default: template
        template_action:
          $ref: '#/components/schemas/TemplateAction'
          description: The template action
      type: object
      required:
        - template_action
      title: RegistryActionTemplateImpl
    RegistryActionUDFImpl:
      properties:
        type:
          type: string
          const: udf
          title: Type
          default: udf
        url:
          type: string
          title: Url
          description: The package url
        module:
          type: string
          title: Module
          description: The module name
        name:
          type: string
          title: Name
          description: The name of the UDF function name
      type: object
      required:
        - url
        - module
        - name
      title: RegistryActionUDFImpl
    RegistryActionOptions:
      properties:
        include_in_schema:
          type: boolean
          title: Include In Schema
          default: true
        requires_approval:
          type: boolean
          title: Requires Approval
          default: false
        required_entitlements:
          anyOf:
            - items:
                type: string
              type: array
            - type: 'null'
          title: Required Entitlements
      type: object
      title: RegistryActionOptions
    RegistrySecret:
      properties:
        type:
          type: string
          const: custom
          title: Type
          default: custom
        name:
          type: string
          pattern: '[a-z0-9_]+'
          title: Name
        keys:
          anyOf:
            - items:
                type: string
                pattern: '[a-zA-Z0-9_]+'
              type: array
            - type: 'null'
          title: Keys
        optional_keys:
          anyOf:
            - items:
                type: string
                pattern: '[a-zA-Z0-9_]+'
              type: array
            - type: 'null'
          title: Optional Keys
        optional:
          type: boolean
          title: Optional
          default: false
        secret_type:
          type: string
          enum:
            - custom
            - ssh_key
            - mtls
            - ca_cert
          title: Secret Type
          default: custom
      type: object
      required:
        - name
      title: RegistrySecret
    RegistryOAuthSecret:
      properties:
        type:
          type: string
          const: oauth
          title: Type
          default: oauth
        provider_id:
          type: string
          title: Provider Id
        grant_type:
          type: string
          enum:
            - authorization_code
            - client_credentials
          title: Grant Type
        optional:
          type: boolean
          title: Optional
          default: false
        name:
          type: string
          title: Name
          readOnly: true
      type: object
      required:
        - provider_id
        - grant_type
        - name
      title: RegistryOAuthSecret
      description: OAuth secret for a provider.
    TemplateAction:
      properties:
        type:
          type: string
          const: action
          title: Type
          default: action
        definition:
          $ref: '#/components/schemas/TemplateActionDefinition'
      type: object
      required:
        - definition
      title: TemplateAction
    TemplateActionDefinition:
      properties:
        name:
          type: string
          title: Name
          description: The action name
        namespace:
          type: string
          title: Namespace
          description: The namespace of the action
        title:
          type: string
          title: Title
          description: The title of the action
        description:
          type: string
          title: Description
          description: The description of the action
          default: ''
        display_group:
          type: string
          title: Display Group
          description: The display group of the action
        doc_url:
          anyOf:
            - type: string
            - type: 'null'
          title: Doc Url
          description: Link to documentation
        author:
          anyOf:
            - type: string
            - type: 'null'
          title: Author
          description: Author of the action
        deprecated:
          anyOf:
            - type: string
            - type: 'null'
          title: Deprecated
          description: Marks action as deprecated along with message
        secrets:
          anyOf:
            - items:
                $ref: '#/components/schemas/RegistrySecretType'
              type: array
            - type: 'null'
          title: Secrets
          description: The secrets to pass to the action
        expects:
          additionalProperties:
            $ref: '#/components/schemas/ExpectedField-Output'
          type: object
          title: Expects
          description: The arguments to pass to the action
        steps:
          items:
            $ref: '#/components/schemas/ActionStep'
          type: array
          title: Steps
          description: The sequence of steps for the action
        returns:
          anyOf:
            - type: string
            - items:
                type: string
              type: array
            - additionalProperties: true
              type: object
          title: Returns
          description: The result of the action
      type: object
      required:
        - name
        - namespace
        - title
        - display_group
        - expects
        - steps
        - returns
      title: TemplateActionDefinition
    ExpectedField-Output:
      additionalProperties: true
      type: object
    ActionStep:
      properties:
        ref:
          type: string
          title: Ref
          description: The reference of the step
        action:
          type: string
          title: Action
        args:
          additionalProperties: true
          type: object
          title: Args
      type: object
      required:
        - ref
        - action
        - args
      title: ActionStep
  securitySchemes:
    APIKeyCookie:
      type: apiKey
      in: cookie
      name: fastapiusersauth

````